/* .c                         freeware                 xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
AB(
int n)
{
fraction InnerProduct_uv;
fraction InnerProduct_vu;

double pbu[MXR][MXC*TWOCOL];matrix mu={MXR,MXC*TWOCOL,&pbu[0][0]};
double pbv[MXR][MXC*TWOCOL];matrix mv={MXR,MXC*TWOCOL,&pbv[0][0]};

   mu.rows = n;           mu.cols = n*TWOCOL;
   mv.rows = n;           mv.cols = n*TWOCOL;
/*-------------------------------- PROGRAM ---------------------------------- */
  rndmF(&mu,5,3);
  rndmF(&mv,5,3);

  clrscrn();
  printf("                                 U");
  printmF3(&mu);
  printf("                                 V");
  printmF3(&mv);

  printf("\n  Properties of inner product in Mnn :");
  printf("\n             (Symetry axiom)         \n");
  printf("\n             <U,V>  =  <V,U>       \n\n");

  InnerProduct_uv = innerprod_Mnm(&mu,&mv);
  printf("  <U,V> =  %6.0lf/%-6.0lf\n\n",
            InnerProduct_uv.numer,
            InnerProduct_uv.denom);

  InnerProduct_vu = innerprod_Mnm(&mv,&mu);
  printf("  <V,U> =  %6.0lf/%-6.0lf \n\n",
            InnerProduct_vu.numer,
            InnerProduct_vu.denom);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.  ");
  printf("\n\n                                                ");
  printf("\n  Properties of inner product in Mnn :         \n");
  printf("\n             (Symetry axiom)                    \n");
  printf("\n\n\n                                              ");
  printf("\n              <U,V>  =  <V,U>                     ");
  printf("\n              ***************                     ");
  printf("\n\n\n\n\n                                          ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                          ");
  printf("\n                                                  ");
  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;
/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 2 && atoi(argv[1]) )
 {n = atoi(argv[1]); if( n > 5){n=5;}}
else
 {    n=rndpI(5);}
   if(n<2){n=2;}


  AB(n);


  printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}












